﻿
Imports System.Net.Sockets
    Imports System.IO
    Imports System.Net
    Imports System.Text.RegularExpressions
    Imports System.Drawing
    Imports System.Text
    Imports System.Windows.Forms
    Imports Microsoft.Data.Sqlite
    Imports Microsoft.Data

Public Class xoredServer



    Dim INI As New IniManager

    Public Port As Integer = 8000
    Public Users As Integer = 0
    Public ConnectedUsers As Integer = 0
    Public IP_TimeOut_Time As Integer = 1000 'Wie lange eine IP nach definierten Aktionen geblockt werden soll
    Public MaxImageSize As Integer = 1398104 'Das ist keine Größeneinheit, sondern die Länge des Strings, in welche das Bild umgewandelt wird
    Public MaxFileSize As Integer = 1398104 'Das ist keine Größeneinheit, sondern die Länge des Strings, in welche das Bild umgewandelt wird
    '1MB ≈ 1398104
    '2MB ≈ 2796204
    '3MB ≈ 4194304
    '4MB ≈ 5592408
    '5MB ≈ 6990508

    Private list As New List(Of Connection)
    Public UserList As New List(Of String)()
    Public TypingUserList As New List(Of String)()
    Public HeartBeatList As New List(Of String)()
    Public IpTimeOutList As New List(Of String)()

    Dim HeartBeatListClearer As New System.Timers.Timer
    Dim iptimeoutclearer As New System.Timers.Timer

    Public EnableBot As Boolean = True     'True = Ein Bot ist immer online, False = Kein Bot ist online
    Public StoreOfflineChat As Boolean = True 'True = Chat wird im Room-Ordner abgespeichert
    Public SendOfflineChatOnJoin As Boolean = True 'True = Der Offline-Chat wird beim Joinen an den Client gesendet
    Public BotName As String = "[Bot]xored" 'Falls ein Bot online sein soll, kann man hier den Namen ändern
    Public DataBaseFileName As String = "Accounts.sqlite"

    Dim LvUserWithIp As New ListView

    ''' <summary>
    ''' Deklarationen
    ''' </summary> 
    Private server As TcpListener
    Private client As New TcpClient
    Private ipendpoint As IPEndPoint = New IPEndPoint(IPAddress.Any, Port)


    ''' <summary>
    ''' Einfache Funktion um alles aus der Konsole auch in eine Textdatei zu schreiben
    ''' </summary>
    Public Function Log(ByVal LogText As String)
        'Dim FILE_NAME As String = My.Computer.FileSystem.CurrentDirectory & "\Log.txt"
        'Dim objWriter As New System.IO.StreamWriter(FILE_NAME, True)
        'objWriter.WriteLine(DateTime.Now.ToString("dd/MM/yyyy HH:mm:ss") & ": " & LogText)
        'objWriter.Close()
    End Function

    ''' <summary>
    ''' Das Struct der Connection
    ''' </summary>
    Private Structure Connection
        Dim stream As NetworkStream
        Dim streamw As StreamWriter
        Dim streamr As StreamReader
        Dim IP As String
        Dim Key As String
        Dim Username As String
    End Structure

    ''' <summary>
    ''' Die Funktion wandelt Bytes zurück in ein Image um
    ''' </summary>
    Private Function BytesToImage(ByVal ImageBytes() As Byte) As Image
        Dim imgNew As Image
        Dim memImage As New System.IO.MemoryStream(ImageBytes)
        imgNew = Image.FromStream(memImage)
        Return imgNew
    End Function

    ''' <summary>
    ''' Die Funktion wandelt ein Image in eine Byte-Sequenz um
    ''' </summary>
    Private Function ImageToBytes(ByVal Image As Image) As Byte()
        Dim memImage As New System.IO.MemoryStream
        Dim bytImage() As Byte
        Image.Save(memImage, Image.RawFormat)
        bytImage = memImage.GetBuffer()
        Return bytImage
    End Function

    ''' <summary>
    ''' Die Funktion wandelt einen String in eine Byte-Sequenz um
    ''' </summary>
    Public Function TextStringToByteArray(ByRef str As String) As Byte()
        Dim enc As System.Text.Encoding = System.Text.Encoding.Default
        Return enc.GetBytes(str)
    End Function

    ''' <summary>
    ''' Die Funktion wandelt ein Byte-Array zu einem Text um
    ''' </summary>
    Public Function ByteArrayToTextString(ByRef Barr() As Byte) As String
        Dim enc As System.Text.Encoding = System.Text.Encoding.Default
        Return enc.GetString(Barr)
    End Function

    ''' <summary>
    ''' Die Funktion sendet einen String an alle verbundenen Clients
    ''' </summary>
    Private Sub SendPacket(ByVal s As String)
        For Each c As Connection In list
            Try
                c.streamw.WriteLine(Encrypt(s, c.Key))
                c.streamw.Flush()
            Catch
            End Try
        Next
    End Sub

    ''' <summary>
    ''' Die Funktion sendet an einen bestimmten Client einen String, der Client wird via IP ausgewählt.
    ''' </summary>
    Private Sub SendPrivatePacket(ByVal s As String, ByVal IP As String)
        For Each c As Connection In list
            Try
                If c.IP = IP Then
                    c.streamw.WriteLine(Encrypt(s, c.Key))
                    c.streamw.Flush()
                End If
            Catch
            End Try
        Next
    End Sub



    ''' <summary>
    ''' Hier wird einfach die Liste der User regelmäßig geleert
    ''' </summary>
    Private Sub HeartBeatListClearerTick(ByVal sender As Object, ByVal e As System.Timers.ElapsedEventArgs)
        HeartBeatList.Clear()
    End Sub

    ''' <summary>
    ''' Hier wird einfach die Liste der User regelmäßig geleert
    ''' </summary>
    Private Sub iptimeoutclearertick(ByVal sender As Object, ByVal e As System.Timers.ElapsedEventArgs)
        IpTimeOutList.Clear()
        TypingUserList.Clear()
        Dim builder As StringBuilder = New StringBuilder()
        For Each val As String In TypingUserList
            builder.Append(val).Append("~nl=")
        Next
        SendPacket("/SendTypingList " & builder.ToString())
    End Sub

    ''' <summary>
    ''' Hier wird ein Random Passwort für die Verschlüsselung gewählt
    ''' </summary>
    Function RandomString(minCharacters As Integer, maxCharacters As Integer)
        Dim s As String = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"
        Static r As New Random
        Dim chactersInString As Integer = r.Next(minCharacters, maxCharacters)
        Dim sb As New StringBuilder
        For i As Integer = 1 To chactersInString
            Dim idx As Integer = r.Next(0, s.Length)
            sb.Append(s.Substring(idx, 1))
        Next
        Return sb.ToString()
    End Function

    Private Sub CreateDataBase()
        Dim connect As New Sqlite.SqliteConnection()
        Dim command As SqliteCommand
        connect.ConnectionString = "Data Source=Accounts.sqlite;"
        connect.Open()
        command = connect.CreateCommand
        command.CommandText = "CREATE TABLE user(ID INTEGER PRIMARY KEY AUTOINCREMENT,Username TEXT,Password TEXT,Friends TEXT);"
        command.ExecuteNonQuery()
        command = connect.CreateCommand
        command.CommandText = "INSERT INTO user (ID, Username, Password, Friends) VALUES (1, '[Bot]Core', '123', '')"
        command.ExecuteNonQuery()
        command.Dispose()
        connect.Close()
    End Sub

    Public Function CheckIfUserVerified(ByVal Username As String, ByVal Password As String) As Boolean
        Dim SQLconnect As New Sqlite.SqliteConnection()
        Dim SQLcommand As SqliteCommand
        SQLconnect.ConnectionString = "Data Source=" & DataBaseFileName & ";"
        SQLconnect.Open()
        SQLcommand = SQLconnect.CreateCommand
        SQLcommand.CommandText = "SELECT count(*) FROM user WHERE Username='" & Username & "' AND Password='" & String2MD5(Password) & "'"
        If (Convert.ToInt32(SQLcommand.ExecuteScalar()) = 0) Then
            Return False
        Else
            Return True
        End If

    End Function

    Public Function StartServer()

        If Not (My.Computer.FileSystem.FileExists(My.Computer.FileSystem.CurrentDirectory & "\Accounts.sqlite")) Then
            Console.WriteLine("No Database found! Generating new one...")
            Console.WriteLine("--------------------------------------------------------------------")
            CreateDataBase()
        Else
            Console.WriteLine("Database found! Connecting to database...")
            Console.WriteLine("--------------------------------------------------------------------")
        End If
        Console.ForegroundColor = ConsoleColor.Cyan

        LvUserWithIp.Columns.Add("Username")
        LvUserWithIp.Columns.Add("IP")
        LvUserWithIp.View = View.Details

        Console.WriteLine("Server has been started...")
        Log("Server has been started...")
        Console.WriteLine("--------------------------------------------------------------------")
        Log("--------------------------------------------------------------------")
        If (EnableBot = True) Then
            UserList.Add("[~1]" & BotName & "[+1]")
        End If
        Console.ResetColor()
        server = New TcpListener(ipendpoint)
        server.Start()

        HeartBeatListClearer.AutoReset = True
        HeartBeatListClearer.Interval = 10000
        AddHandler HeartBeatListClearer.Elapsed, AddressOf HeartBeatListClearerTick
        HeartBeatListClearer.Start()

        iptimeoutclearer.AutoReset = True
        iptimeoutclearer.Interval = IP_TimeOut_Time
        AddHandler iptimeoutclearer.Elapsed, AddressOf iptimeoutclearertick
        iptimeoutclearer.Start()

        While True
            client = server.AcceptTcpClient
            Dim Connection As New Connection
            Connection.stream = client.GetStream
            Connection.streamr = New StreamReader(Connection.stream)
            Connection.streamw = New StreamWriter(Connection.stream)
            Connection.IP = (IPAddress.Parse(CType(client.Client.RemoteEndPoint, IPEndPoint).Address.ToString())).ToString()
            Connection.Key = RandomString(10, 15)
            list.Add(Connection)
            Connection.streamw.WriteLine(Encrypt("/Key " & Connection.Key, "xored"))
            Connection.streamw.Flush()

            ''''
            '''' Falls die IP des Clients in der Textdatei vorkommt, wird der Client wieder gekickt
            ''''
            Dim ipend As String = (IPAddress.Parse(CType(client.Client.RemoteEndPoint, IPEndPoint).Address.ToString())).ToString()
            Dim IpReader = My.Computer.FileSystem.ReadAllText(My.Computer.FileSystem.CurrentDirectory & "\BannedIPs.txt")
            If (IpReader.Contains(ipend)) Then
                list.Remove(Connection)
                Connection.stream.Close()
                Connection.stream.Dispose()
                Connection.streamw.Close()
                Connection.streamw.Dispose()
                Connection.streamr.Close()
                Connection.streamr.Dispose()
            Else
                Console.ForegroundColor = ConsoleColor.Green
                Console.WriteLine(ipend & ": Received connection")
                Log(ipend & ": Received connection")
                Console.WriteLine("--------------------------------------------------------------------")
                Log("--------------------------------------------------------------------")
                ConnectedUsers = ConnectedUsers + 1
                SendPacket("/OnlineUsers " & ConnectedUsers)
                Console.ResetColor()
                Dim ListenToConnectionThread As New Threading.Thread(AddressOf ListenToConnection)
                ListenToConnectionThread.Start(Connection)

            End If


        End While


    End Function

    Private Sub ListenToConnection(ByVal con As Connection)
        Do
            Try
                Dim ipend As String = (IPAddress.Parse(CType(client.Client.RemoteEndPoint, IPEndPoint).Address.ToString())).ToString()
                Dim tmp As String = Decrypt(con.streamr.ReadLine, con.Key)

                Try
                    ''''
                    '''' /register Benutzername Passwort PacketID <- Registriert einen neuen Benutzer, falls noch nicht existent
                    ''''
                    If tmp.Contains("/register") Then
                        Console.WriteLine(ipend & ": Recv RegPacket")
                        Log(ipend & ": Recv RegPacket")
                        Dim Success As Boolean = False
                        Dim str() = {tmp}
                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)
                            Console.WriteLine(ipend & ": RecvID:{0}  |  RecvPW:{1}  |  PacketID:{2}", splitString(1), splitString(2), splitString(3))
                            Log(ipend & ": RecvID:{0}  |  RecvPW:{1}  |  PacketID:{2} " & splitString(1) & " " & splitString(2) & " " & splitString(3))

                            Dim SQLconnect As New Sqlite.SqliteConnection()
                            Dim SQLcommand As SqliteCommand
                            SQLconnect.ConnectionString = "Data Source=" & DataBaseFileName & ";"
                            SQLconnect.Open()
                            SQLcommand = SQLconnect.CreateCommand
                            SQLcommand.CommandText = "SELECT count(*) FROM user WHERE Username='" & splitString(1) & "'"
                            Dim count As Integer = Convert.ToInt32(SQLcommand.ExecuteScalar())
                            Dim FreeID As Integer = 0
                            If count = 0 Then
                                Success = True
                                count = count + 1
                                SQLcommand.CommandText = "SELECT count(*) FROM user"
                                FreeID = Convert.ToInt32(SQLcommand.ExecuteScalar())
                                FreeID = FreeID + 1
                            Else
                                Success = False
                            End If



                            SQLcommand.Dispose()
                            SQLconnect.Close()


                            ''''
                            '''' Verbotene Zeichen im Benutzernamen werden hier rausgefiltert -> Client bekommt einen Fehler
                            ''''
                            If (splitString(1).Contains("[~1]")) Then
                                Success = False
                            End If
                            If (splitString(1).Contains("[+1]")) Then
                                Success = False
                            End If

                            If (splitString(1).Contains("[")) Then
                                Success = False
                            End If
                            If (splitString(1).Contains("]")) Then
                                Success = False
                            End If
                            If (Success = False) Then
                                Console.WriteLine(ipend & ": Account does already exist.")
                                Log(ipend & ": Account does already exist.")
                                SendPrivatePacket("PacketID: " & splitString(3) & " regReturn 1", ipend)
                                Console.WriteLine("--------------------------------------------------------------------")
                                Log("--------------------------------------------------------------------")
                            Else
                                ''''
                                '''' Die IP-Timeout-Liste ist dafür da um das Spammen des Register-Packets zu verhindern
                                ''''
                                If Not IpTimeOutList.Contains(ipend) Then

                                    Dim SQLconnect2 As New Sqlite.SqliteConnection()
                                    Dim SQLcommand2 As SqliteCommand
                                    SQLconnect2.ConnectionString = "Data Source=" & DataBaseFileName & ";"
                                    SQLconnect2.Open()
                                    SQLcommand2 = SQLconnect2.CreateCommand
                                    SQLcommand2.CommandText = "INSERT INTO user (ID, Username, Password, Friends) VALUES ('" & FreeID & "', '" & splitString(1) & "', '" & String2MD5(splitString(2)) & "', '')"
                                    SQLcommand2.ExecuteNonQuery()
                                    SQLcommand2.Dispose()
                                    SQLconnect2.Close()
                                    Log(ipend & ": Account " & """" & splitString(1) & """" & "  has been created.")
                                    Console.WriteLine(ipend & ": Account " & """" & splitString(1) & """" & "  has been created.")
                                    SendPrivatePacket("PacketID: " & splitString(3) & " regReturn 0", ipend)
                                    Console.WriteLine("--------------------------------------------------------------------")
                                    Log("--------------------------------------------------------------------")
                                    IpTimeOutList.Add(ipend)

                                End If
                            End If
                        Next
                    End If

                    ''''
                    '''' /login Benutzername Passwort PacketID zum Einloggen des Clients
                    ''''
                    If tmp.Contains("/login") Then
                        Console.WriteLine(ipend & ": Recv LoginPacket")
                        Log(ipend & ": Recv LoginPacket")
                        Dim Success As Boolean = False
                        Dim str() = {tmp}
                        Dim splitstring1 As String
                        Dim splitstring2 As String
                        Dim splitstring3 As String

                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)
                            splitstring1 = splitString(1)
                            splitstring2 = splitString(2)
                            splitstring3 = splitString(3)
                        Next
                        Console.WriteLine(ipend & ": RecvID:{0}  |  RecvPW:{1}  |  PacketID:{2}", splitstring1, splitstring2, splitstring3)
                        Log(ipend & ": RecvID:{0}  |  RecvPW:{1}  |  PacketID:{2} " & splitstring1 & " " & splitstring2 & " " & splitstring3)
                        Try
                            If CheckIfUserVerified(splitstring1, splitstring2) = True Then
                                Success = True
                            Else
                                Success = False
                            End If
                        Catch ex As Exception
                            Success = False
                        End Try
                        If (Success = False) Then
                            Console.WriteLine(ipend & ": Wrong username or password.")
                            Log(ipend & ": Wrong username or password.")
                            SendPrivatePacket("PacketID: " & splitstring3 & " logReturn 1", ipend)
                            Console.WriteLine("--------------------------------------------------------------------")
                            Log("--------------------------------------------------------------------")
                        Else
                            Console.WriteLine(ipend & ": Account " & """" & splitstring1 & """" & "  has logged in.")
                            Log(ipend & ": Account " & """" & splitstring1 & """" & "  has logged in.")
                            SendPrivatePacket("PacketID: " & splitstring3 & " logReturn 0", ipend)
                            HeartBeatList.Add("[~1]" & splitstring1 & "[+1]")
                            con.Username = splitstring1
                            Dim _itm As ListViewItem
                            Dim Ergebnis As Boolean = False
                            For Each _itm In LvUserWithIp.Items
                                If (_itm.SubItems(0).Text).ToString.Equals("[~1]" & splitstring1 & "[+1]") Then
                                    Ergebnis = True
                                    Exit For
                                End If
                            Next
                            If Not (Ergebnis = True) Then
                                With LvUserWithIp.Items.Add("[~1]" & splitstring1 & "[+1]")
                                    .SubItems.Add(ipend)
                                End With
                                Console.WriteLine("--------------------------------------------------------------------")
                                Log("--------------------------------------------------------------------")
                                SendPacket("/JoinedPacket")
                                Dim _itm2 As ListViewItem

                            End If
                        End If
                    End If

                    ''''
                    '''' Der Befehl wird vom Client gesendet, wenn er joined. Hier wird der Benutzername dann der Userlist hinzugefügt.
                    '''' Die Userlist wird anschließend an alle Clients gesendet.
                    ''''
                    If tmp.Contains("/SendNick") Then
                        Console.WriteLine(ipend & ": Recv SendNickPacket")
                        Log(ipend & ": Recv SendNickPacket")
                        Dim str() = {tmp}
                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)
                            Console.WriteLine(ipend & ": PacketID:{0} ", splitString(2))
                            Log(ipend & ": PacketID:{0} " & splitString(2))
                            Dim BuilderNew As String
                            If Not (UserList.Contains("[~1]" & splitString(1) & "[+1]")) Then
                                UserList.Add("[~1]" & splitString(1) & "[+1]")
                                For Each val As String In UserList
                                    BuilderNew = BuilderNew & val
                                Next
                                SendPacket("/SendNickList " & BuilderNew)
                                Console.WriteLine("Current Nicks: " & BuilderNew)
                            Else
                                Console.WriteLine("Current Nicks: " & BuilderNew)
                            End If
                        Next
                    End If

                    ''''
                    '''' Hier werden die Heartbeat-Packets von den Clients angenommen und der Liste hinzugefügt, welche vom Timer dann später gecheckt wird.
                    ''''
                    If tmp.Contains("/SendMyHeartBeat") Then
                        ' Console.WriteLine(ipend & ": Recv SendMyHeartBeatPacket")
                        'Log(ipend & ": Recv SendMyHeartBeatPacket")
                        Dim str() = {tmp}
                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)
                            'Console.WriteLine(ipend & ": RecvUsername:{0}", splitString(1))
                            ' Log(ipend & ": RecvUsername:{0} " & splitString(1))

                            If CheckIfUserVerified(splitString(1), splitString(2)) = True Then
                                If (EnableBot = True) Then
                                    If Not (HeartBeatList.Contains("[~1]" & "[Bot]Core" & "[+1]")) Then
                                        HeartBeatList.Add("[~1]" & "[Bot]Core" & "[+1]")
                                    End If
                                End If
                                If Not (HeartBeatList.Contains("[~1]" & splitString(1) & "[+1]")) Then
                                    HeartBeatList.Add("[~1]" & splitString(1) & "[+1]")
                                End If
                                Dim BuilderNew As String = ""
                                For Each val As String In HeartBeatList
                                    BuilderNew = BuilderNew & val
                                Next

                                SendPacket("/SendNickList " & BuilderNew)
                                SendPacket("/OnlineUsers " & HeartBeatList.Count)

                            End If
                            ' Console.WriteLine("--------------------------------------------------------------------")
                            'Log("--------------------------------------------------------------------")
                        Next
                    End If

                    ''''
                    '''' /invite TargetUsername SenderUsername SenderPassword
                    '''' Hier wird eine Freundschafts-Einladung an einen spezifischen User gesendet. 
                    '''' Die IP wird via Benutzernamen herausgefunden. 
                    '''' Die Daten des Senders dienen zur Authentifizierung, sodass kein Dritt-Anbieter-TCP-Client dieses Paket im Namen des Senders senden kann.
                    ''''
                    If tmp.Contains("/Invite") Then
                        Console.WriteLine(ipend & ": Recv InvitePacket")
                        Log(ipend & ": Recv InvitePacket")
                        Dim str() = {tmp}
                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)
                            Log(ipend & ": InviteTaget:{0}  |  SenderUsername:{1}  |  SenderPassword:{2} " & splitString(1) & " " & splitString(2) & " " & splitString(3))
                            Console.WriteLine(ipend & ": InviteTaget:{0}  |  SenderUsername:{1}  |  SenderPassword:{2}", splitString(1), splitString(2), splitString(3))
                            If CheckIfUserVerified(splitString(2), splitString(3)) = True Then
                                If Not INI.INI_ReadValueFromFile("Information", "Friends", "", My.Computer.FileSystem.CurrentDirectory & "\Accounts\" & splitString(2) & ".ini").Contains("[~1]" & splitString(1) & "[+1]") Then
                                    SendPacket("/SendInviteToClient " & splitString(1) & " " & splitString(2))
                                End If
                            End If
                            Log("--------------------------------------------------------------------")
                            Console.WriteLine("--------------------------------------------------------------------")
                        Next
                    End If

                    ''''
                    '''' /DeleteFriend TargetUsername SenderUsername SenderPassword
                    '''' Hier wird eine Freundschaft beidseitig entfernt.
                    '''' Die Daten des Senders dienen zur Authentifizierung, sodass kein Dritt-Anbieter-TCP-Client dieses Paket im Namen des Senders senden kann.
                    ''''
                    If tmp.Contains("/DeleteFriend") Then
                        Console.WriteLine(ipend & ": Recv DeleteFriendPacket")
                        Log(ipend & ": Recv DeleteFriendPacket")
                        Dim str() = {tmp}
                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)
                            Log(ipend & ": DeleteTaget:{0}  |  SenderUsername:{1}  |  SenderPassword:{2}" & splitString(1) & " " & splitString(2) & " " & splitString(3))
                            Console.WriteLine(ipend & ": DeleteTaget:{0}  |  SenderUsername:{1}  |  SenderPassword:{2}", splitString(1), splitString(2), splitString(3))
                            If CheckIfUserVerified(splitString(2), splitString(3)) = True Then
                                Dim OldFriendList As String = ""

                                Dim SQLconnect As New Sqlite.SqliteConnection()
                                Dim SQLcommand As SqliteCommand
                                SQLconnect.ConnectionString = "Data Source=" & DataBaseFileName & ";"
                                SQLconnect.Open()
                                SQLcommand = SQLconnect.CreateCommand
                                SQLcommand.CommandText = "SELECT * FROM user Where Username = '" & splitString(2) & "'"
                                Dim SQLreader As SqliteDataReader = SQLcommand.ExecuteReader()

                                While SQLreader.Read()
                                    OldFriendList = SQLreader(3)
                                End While
                                SQLcommand.Dispose()
                                SQLconnect.Close()

                                OldFriendList = OldFriendList.Replace(splitString(1), "")

                                Dim SQLconnect3 As New Sqlite.SqliteConnection()
                                Dim SQLcommand3 As SqliteCommand
                                SQLconnect3.ConnectionString = "Data Source=" & DataBaseFileName & ";"
                                SQLconnect3.Open()
                                SQLcommand3 = SQLconnect3.CreateCommand
                                SQLcommand3.CommandText = "UPDATE user SET Friends='" & OldFriendList & "' WHERE Username='" & splitString(2) & "'"
                                SQLcommand3.ExecuteNonQuery()
                                SQLcommand3.Dispose()
                                SQLconnect3.Close()

                                Dim OldFriendList2 As String = ""

                                Dim SQLconnect2 As New Sqlite.SqliteConnection()
                                Dim SQLcommand2 As SqliteCommand
                                SQLconnect2.ConnectionString = "Data Source=" & DataBaseFileName & ";"
                                SQLconnect2.Open()
                                SQLcommand2 = SQLconnect2.CreateCommand
                                SQLcommand2.CommandText = "SELECT * FROM user Where Username = '" & splitString(1) & "'"
                                Dim SQLreader2 As SqliteDataReader = SQLcommand2.ExecuteReader()

                                While SQLreader2.Read()
                                    OldFriendList2 = SQLreader2(3)
                                End While
                                SQLcommand2.Dispose()
                                SQLconnect2.Close()

                                OldFriendList2 = OldFriendList2.Replace(splitString(1), "")

                                Dim SQLconnect4 As New Sqlite.SqliteConnection()
                                Dim SQLcommand4 As SqliteCommand
                                SQLconnect4.ConnectionString = "Data Source=" & DataBaseFileName & ";"
                                SQLconnect4.Open()
                                SQLcommand4 = SQLconnect4.CreateCommand
                                SQLcommand4.CommandText = "UPDATE user SET Friends='" & OldFriendList2 & "' WHERE Username='" & splitString(1) & "'"
                                SQLcommand4.ExecuteNonQuery()
                                SQLcommand4.Dispose()
                                SQLconnect4.Close()

                            End If
                            Console.WriteLine("--------------------------------------------------------------------")
                            Log("--------------------------------------------------------------------")
                        Next
                    End If

                    ''''
                    '''' /AcceptInvite AcceptTarget Sender SenderUsername SenderPassword PacketID
                    '''' Hier wird eine Freundschafts-Einladung akzeptiert
                    '''' Die Freundschaft wird beidseitig eingetragen.
                    '''' Die Daten des Senders dienen zur Authentifizierung, sodass kein Dritt-Anbieter-TCP-Client dieses Paket im Namen des Senders senden kann.
                    '''' Paket-Typ: Privat (Paket geht nur an den spezifischen Client)
                    ''''
                    If tmp.Contains("/AcceptInvite") Then
                        Console.WriteLine(ipend & ": Recv AcceptInvitePacket")
                        Log(ipend & ": Recv AcceptInvitePacket")
                        Dim str() = {tmp}

                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)
                            Console.WriteLine(ipend & ": AcceptTarget:{0}  |  Sender:{1}  |  SenderUsername:{2}  |  SenderPassword:{3}  |  PacketID:{1}", splitString(1), splitString(2), splitString(3), splitString(4), splitString(5))
                            Log(ipend & ": AcceptTarget:{0}  |  Sender:{1}  |  SendeUsername:{2}  |  SenderPassword:{3}  |  PacketID:{1} " & splitString(1) & " " & splitString(2) & " " & splitString(3) & " " & splitString(4) & " " & splitString(5))
                            If CheckIfUserVerified(splitString(3), splitString(4)) = True Then

                                Dim Friends1 As String = ""
                                Dim Friends2 As String = ""

                                Dim SQLconnect As New Sqlite.SqliteConnection()
                                Dim SQLcommand As SqliteCommand
                                SQLconnect.ConnectionString = "Data Source=" & DataBaseFileName & ";"
                                SQLconnect.Open()
                                SQLcommand = SQLconnect.CreateCommand
                                SQLcommand.CommandText = "SELECT * FROM user Where Username = '" & splitString(2) & "'"
                                Dim SQLreader As SqliteDataReader = SQLcommand.ExecuteReader()

                                While SQLreader.Read()
                                    Friends1 = SQLreader(3)
                                End While
                                SQLcommand.Dispose()
                                SQLconnect.Close()

                                Dim SQLconnect2 As New Sqlite.SqliteConnection()
                                Dim SQLcommand2 As SqliteCommand
                                SQLconnect2.ConnectionString = "Data Source=" & DataBaseFileName & ";"
                                SQLconnect2.Open()
                                SQLcommand2 = SQLconnect2.CreateCommand
                                SQLcommand2.CommandText = "SELECT * FROM user Where Username = '" & splitString(1) & "'"
                                Dim SQLreader2 As SqliteDataReader = SQLcommand2.ExecuteReader()

                                While SQLreader2.Read()
                                    Friends2 = SQLreader2(3)
                                End While
                                SQLcommand2.Dispose()
                                SQLconnect2.Close()

                                If Not Friends1.Contains("[~1]" & splitString(1) & "[+1]") Then
                                    If Not Friends2.Contains("[~1]" & splitString(2) & "[+1]") Then
                                        Dim OldFriendList As String = Friends1
                                        OldFriendList = OldFriendList & "[~1]" & splitString(1) & "[+1]"

                                        Dim SQLconnect4 As New Sqlite.SqliteConnection()
                                        Dim SQLcommand4 As SqliteCommand
                                        SQLconnect4.ConnectionString = "Data Source=" & DataBaseFileName & ";"
                                        SQLconnect4.Open()
                                        SQLcommand4 = SQLconnect4.CreateCommand
                                        SQLcommand4.CommandText = "UPDATE user SET Friends='" & OldFriendList & "' WHERE Username='" & splitString(2) & "'"
                                        SQLcommand4.ExecuteNonQuery()
                                        SQLcommand4.Dispose()
                                        SQLconnect4.Close()

                                        Dim OldFriendList2 As String = Friends2
                                        OldFriendList2 = OldFriendList2 & "[~1]" & splitString(2) & "[+1]"

                                        Dim SQLconnect3 As New Sqlite.SqliteConnection()
                                        Dim SQLcommand3 As SqliteCommand
                                        SQLconnect3.ConnectionString = "Data Source=" & DataBaseFileName & ";"
                                        SQLconnect3.Open()
                                        SQLcommand3 = SQLconnect3.CreateCommand
                                        SQLcommand3.CommandText = "UPDATE user SET Friends='" & OldFriendList2 & "' WHERE Username='" & splitString(1) & "'"
                                        SQLcommand3.ExecuteNonQuery()
                                        SQLcommand3.Dispose()
                                        SQLconnect3.Close()

                                        Dim TargetIP As String
                                        Dim pos As Int32
                                        Dim listItem As ListViewItem
                                        For pos = LvUserWithIp.Items.Count - 1 To 0 Step -1
                                            listItem = LvUserWithIp.Items(pos)
                                            If listItem.SubItems(0).Text = "[~1]" & splitString(1) & "[+1]" Then
                                                TargetIP = listItem.SubItems(1).Text
                                            End If
                                        Next
                                        If Not (String.IsNullOrEmpty(TargetIP)) Then
                                            SendPrivatePacket("/SendFriendListToClient " & splitString(1) & " " & INI.INI_ReadValueFromFile("Information", "Friends", "", My.Computer.FileSystem.CurrentDirectory & "\Accounts\" & splitString(1) & ".ini"), TargetIP)
                                        End If
                                        SendPrivatePacket("/SendFriendListToClient " & splitString(2) & " " & INI.INI_ReadValueFromFile("Information", "Friends", "", My.Computer.FileSystem.CurrentDirectory & "\Accounts\" & splitString(2) & ".ini"), ipend)
                                    End If
                                End If
                            End If
                            Log("--------------------------------------------------------------------")
                            Console.WriteLine("--------------------------------------------------------------------")
                        Next
                    End If

                    ''''
                    '''' /RequestFriendList RequestedName Username Password
                    '''' Hier wird die Freundschafts-Liste ausgelesen
                    '''' Die Daten des Senders dienen zur Authentifizierung, sodass kein Dritt-Anbieter-TCP-Client dieses Paket im Namen des Senders senden kann.
                    '''' Paket-Typ: Privat (Paket geht nur an den spezifischen Client)
                    ''''
                    If tmp.Contains("/RequestFriendList") Then
                        Console.WriteLine(ipend & ": Recv RequestFriendListPacket")
                        Log(ipend & ": Recv RequestFriendListPacket")
                        Dim str() = {tmp}
                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)
                            Console.WriteLine(ipend & ": RequestedName:{0}  |  Username:{1}  |  Password:{2}", splitString(1), splitString(2), splitString(3))
                            Log(ipend & ": RequestedName:{0}  |  Username:{1}  |  Password:{2} " & splitString(1) & " " & splitString(2) & " " & splitString(3))
                            If CheckIfUserVerified(splitString(1), splitString(3)) = True Then
                                Dim SQLconnect As New Sqlite.SqliteConnection()
                                Dim SQLcommand As SqliteCommand
                                SQLconnect.ConnectionString = "Data Source=" & DataBaseFileName & ";"
                                SQLconnect.Open()
                                SQLcommand = SQLconnect.CreateCommand
                                SQLcommand.CommandText = "SELECT * FROM user Where Username = '" & splitString(2) & "' AND Password = '" & String2MD5(splitString(3)) & "'"
                                Dim SQLreader As SqliteDataReader = SQLcommand.ExecuteReader()
                                Dim FriendsList As String = ""
                                While SQLreader.Read()
                                    FriendsList = SQLreader(3)
                                End While
                                SQLcommand.Dispose()
                                SQLconnect.Close()
                                SendPrivatePacket("/SendFriendListToClient " & splitString(2) & " " & FriendsList, ipend)
                            End If
                            Console.WriteLine("--------------------------------------------------------------------")
                            Log("--------------------------------------------------------------------")
                        Next
                    End If

                    ''''
                    '''' /DeleteNick Username
                    '''' Hier wird der Benutzer aus der Nicklist entfernt, dies passiert beim Beenden des Clients.
                    '''' Die Daten des Senders dienen zur Authentifizierung, sodass kein Dritt-Anbieter-TCP-Client dieses Paket im Namen des Senders senden kann.
                    '''' MUSS ÜBERARBEITET WERDEN
                    ''''
                    If tmp.Contains("/DeleteNick") Then
                        Console.WriteLine(ipend & ": Recv DeleteNickPacket")
                        Log(ipend & ": Recv DeleteNickPacket")
                        Dim str() = {tmp}
                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)
                            Console.WriteLine(ipend & ": PacketID:{0} ", splitString(1))
                            Log(ipend & ": PacketID:{0} " & splitString(1))
                            UserList.Remove("[~1]" & splitString(1) & "[+1]")
                            Dim UserListToString As String
                            For Each val As String In UserList
                                UserListToString = UserListToString & val
                            Next
                            SendPacket("/SendNickList " & UserListToString)
                        Next
                    End If

                    ''''
                    '''' /StartTyping SenderUsername PacketID
                    '''' Wenn das Paket empfangen wird, wird der Sender den anderen Clients als "schreibend" angezeigt.
                    ''''
                    If tmp.Contains("/StartTyping") Then
                        Console.WriteLine(ipend & ": Recv StartTypingPacket")
                        Log(ipend & ": Recv StartTypingPacket")
                        Dim str() = {tmp}
                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)

                            Console.WriteLine(ipend & ": RecvSender:{0}  |  PacketID:{1}  ", splitString(1), splitString(2))
                            Log(ipend & ": RecvSender:{0}  |  PacketID:{1}  " & splitString(1) & " " & splitString(2))
                            If CheckIfUserVerified(splitString(1), splitString(3)) = True Then
                                If Not TypingUserList.Contains(splitString(1)) Then
                                    TypingUserList.Add(splitString(1))
                                End If
                                If Not TypingUserList.Count = 0 Then
                                    Dim builder As StringBuilder = New StringBuilder()
                                    For Each val As String In TypingUserList
                                        builder.Append(val).Append("~nl=")
                                    Next
                                    SendPacket("/SendTypingList " & builder.ToString())
                                End If
                            End If
                            Console.WriteLine("--------------------------------------------------------------------")
                            Log("--------------------------------------------------------------------")
                        Next
                    End If

                    ''''
                    '''' /StopTyping SenderUsername PacketID
                    '''' Der Nutzer wird aus der Liste der Schreibenden herausgenommen.
                    ''''
                    If tmp.Contains("/StopTyping") Then
                        Console.WriteLine(ipend & ": Recv StopTypingPacket")
                        Log(ipend & ": Recv StopTypingPacket")
                        Dim str() = {tmp}
                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)
                            Console.WriteLine(ipend & ": RecvSender:{0}  |  PacketID:{1}  ", splitString(1), splitString(2))
                            Log(ipend & ": RecvSender:{0}  |  PacketID:{1}  " & splitString(1) & " " & splitString(2))
                            If (splitString(3) = INI.INI_ReadValueFromFile("Information", "Password", "", My.Computer.FileSystem.CurrentDirectory & "\Accounts\" & splitString(1) & ".ini")) Then
                                If TypingUserList.Contains(splitString(1)) Then
                                    TypingUserList.Remove(splitString(1))
                                End If
                                Dim builder As StringBuilder = New StringBuilder()
                                For Each val As String In TypingUserList
                                    builder.Append(val).Append("~nl=")
                                Next
                                SendPacket("/SendTypingList " & builder.ToString())
                            End If
                            Log("--------------------------------------------------------------------")
                            Console.WriteLine("--------------------------------------------------------------------")
                        Next
                    End If

                    ''''
                    '''' /RequestChat
                    '''' Hier wird der gesamte bisherige Chat an einen Client gesendet.
                    ''''
                    If tmp.Contains("/RequestChat") Then
                        Log(ipend & ": Recv RequestChatPacket")
                        Console.WriteLine(ipend & ": Recv RequestChatPacket")
                        Dim str() = {tmp}
                        For Each Word In str
                            If Not IpTimeOutList.Contains(ipend) Then
                                Dim di As New DirectoryInfo(My.Computer.FileSystem.CurrentDirectory & "\Room\")
                                Dim fiArr As FileInfo() = di.GetFiles().OrderBy(Function(fi) CInt(IO.Path.GetFileNameWithoutExtension(fi.Name))).ToArray()
                                Dim fri As FileInfo
                                For Each fri In fiArr
                                    Dim regx = New Regex(" +")
                                    Dim splitString = regx.Split(Word)
                                    Console.WriteLine(ipend & ": PacketID:{0} ", splitString(1))
                                    Log(ipend & ": PacketID:{0} " & splitString(1))
                                    Dim Room As String = splitString(2)
                                    Dim WholeChat As String = My.Computer.FileSystem.ReadAllText(My.Computer.FileSystem.CurrentDirectory & "\Room\" & fri.Name)
                                    WholeChat = WholeChat.Replace(Environment.NewLine, "~nl=")
                                    WholeChat = WholeChat.Replace(" ", "'sp%")
                                    If (SendOfflineChatOnJoin = True) Then
                                        SendPrivatePacket(splitString(1) & " SendWholeChat" & " " & WholeChat & " " & Room, ipend)
                                    End If
                                Next fri
                                IpTimeOutList.Add(ipend)
                            End If
                            Log("--------------------------------------------------------------------")
                            Console.WriteLine("--------------------------------------------------------------------")
                        Next
                    End If

                    ''''
                    '''' /SendImage User Image
                    '''' Hier wird das Bild eines Nutzers angenommen, sofern es nicht die Maximalgröße überschreitet.
                    ''''
                    If tmp.Contains("/SendImage") Then
                        Log(ipend & ": Recv SendImagePacket")
                        Console.WriteLine(ipend & ": Recv SendImagePacket")
                        Dim str() = {tmp}
                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)
                            Dim User As String = (splitString(1))
                            Dim BaseImage As String = (splitString(2))
                            Console.WriteLine(ipend & ": Recvd Image")
                            Log(ipend & ": Recvd Image")
                            If (splitString(2).Length < MaxImageSize) Then
                                If Not IpTimeOutList.Contains(ipend) Then
                                    If (My.Computer.FileSystem.FileExists(My.Computer.FileSystem.CurrentDirectory & "\Images\" & User & ".txt")) Then
                                        My.Computer.FileSystem.DeleteFile(My.Computer.FileSystem.CurrentDirectory & "\Images\" & User & ".txt")
                                    End If
                                    Dim objWriter As New System.IO.StreamWriter(My.Computer.FileSystem.CurrentDirectory & "\Images\" & User & ".txt")
                                    objWriter.Write(BaseImage)
                                    objWriter.Close()
                                    IpTimeOutList.Add(ipend)
                                End If
                            End If
                            Log("--------------------------------------------------------------------")
                            Console.WriteLine("--------------------------------------------------------------------")
                        Next
                    End If

                    ''''
                    '''' /Chat Benutzername Nachricht PacketID
                    '''' Hier werden Nachrichten empfangen und an alle Clients weitergegeben
                    ''''
                    If tmp.Contains("/Chat") Then
                        Console.WriteLine(ipend & ": Recv ChatPacket")
                        Log(ipend & ": Recv ChatPacket")
                        Dim RecvID As String
                        Dim RecvMessage As String
                        Dim str() = {tmp}
                        Dim Room As String
                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)
                            Console.WriteLine(ipend & ": RecvID:{0}  |  RecvMessage:{1}  |  PacketID:{2}", splitString(1), splitString(2), splitString(3))
                            Log(ipend & ": RecvID:{0}  |  RecvMessage:{1}  |  PacketID:{2} " & splitString(1) & " " & splitString(2) & " " & splitString(3))
                            RecvID = Word(1)
                            RecvMessage = Word
                            Room = splitString(4)
                            Dim Password As String = splitString(5)
                            Console.WriteLine(ipend & ": Account " & """" & splitString(1) & """" & "  has sent a Message.")
                            Log(ipend & ": Account " & """" & splitString(1) & """" & "  has sent a Message.")
                            If Not (String.IsNullOrEmpty(splitString(2))) Then
                                If CheckIfUserVerified(splitString(1), Password) = True Then
                                    If Not IpTimeOutList.Contains(ipend) Then
                                        If Not (splitString(2).Length > 200) Then
                                            SendPacket("/ChatIncome: " & splitString(1) & " " & splitString(2) & " " & Room)
                                            Dim RoomCount As Integer = Directory.GetFiles(My.Computer.FileSystem.CurrentDirectory & "\Room\", "*.txt").Count
                                            Dim fi As New IO.FileInfo(My.Computer.FileSystem.CurrentDirectory & "\Room\" & RoomCount & ".txt")
                                            Dim size As Long = fi.Length
                                            'Größencheck
                                            If (size < 500000) Then
                                                Using sw As StreamWriter = File.AppendText(My.Computer.FileSystem.CurrentDirectory & "\Room\" & RoomCount & ".txt")
                                                    If (StoreOfflineChat = True) Then
                                                        sw.WriteLine(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") & "'sp%-'sp%" & splitString(1) & ": " & splitString(2))
                                                    End If
                                                End Using
                                            Else
                                                RoomCount = RoomCount + 1
                                                Using sw As StreamWriter = File.AppendText(My.Computer.FileSystem.CurrentDirectory & "\Room\" & RoomCount & ".txt")
                                                    If (StoreOfflineChat = True) Then
                                                        sw.WriteLine(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") & "'sp%-'sp%" & splitString(1) & ": " & splitString(2))
                                                    End If
                                                End Using
                                            End If
                                            IpTimeOutList.Add(ipend)

                                        Else
                                            SendPacket("/TimeOutPacket: " & splitString(1))
                                        End If
                                    Else
                                        SendPacket("/TimeOutPacket: " & splitString(1))
                                    End If
                                End If
                            End If
                            Log("--------------------------------------------------------------------")
                            Console.WriteLine("--------------------------------------------------------------------")
                        Next
                    End If

                    ''''
                    '''' /PChat Sender Empfänger SenderPasswort 
                    '''' Hier wird eine Private Nachricht an einen spezifischen Client gesendet.
                    '''' Die IP wird via Benutzernamen herausgefunden. 
                    '''' Die Daten des Senders dienen zur Authentifizierung, sodass kein Dritt-Anbieter-TCP-Client dieses Paket im Namen des Senders senden kann.
                    ''''
                    If tmp.Contains("/PChat") Then
                        Log(ipend & ": Recv PrivateChatPacket")
                        Console.WriteLine(ipend & ": Recv PrivateChatPacket")
                        Dim str() = {tmp}
                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)
                            Dim Password As String = splitString(4)
                            If CheckIfUserVerified(splitString(2), Password) = True Then
                                If Not IpTimeOutList.Contains(ipend) Then
                                    If Not (splitString(3).Length > 200) Then
                                        Console.WriteLine(ipend & ": RecvSender:{0}  |  RecvTarget:{1}  |  RecvMessage:{2}", splitString(2), splitString(1), splitString(3))
                                        Log(ipend & ": RecvSender:{0}  |  RecvTarget:{1}  |  RecvMessage:{2} " & splitString(2) & " " & splitString(1) & " " & splitString(3))
                                        Console.WriteLine(ipend & ": Account " & """" & splitString(2) & """" & "  has sent " & splitString(1) & " a PrivateMessage.")
                                        Log(ipend & ": Account " & """" & splitString(2) & """" & "  has sent " & splitString(1) & " a PrivateMessage.")
                                        Dim TargetIP As String
                                        Dim pos As Int32
                                        Dim listItem As ListViewItem
                                        For pos = LvUserWithIp.Items.Count - 1 To 0 Step -1
                                            listItem = LvUserWithIp.Items(pos)
                                            If listItem.SubItems(0).Text = "[~1]" & splitString(1) & "[+1]" Then
                                                TargetIP = listItem.SubItems(1).Text
                                            End If
                                        Next
                                        If Not (String.IsNullOrEmpty(TargetIP)) Then
                                            SendPrivatePacket("/PChatInc " & splitString(1) & " " & splitString(2) & " " & splitString(3), TargetIP)
                                        End If
                                        Console.WriteLine("--------------------------------------------------------------------")
                                        Log("--------------------------------------------------------------------")
                                        IpTimeOutList.Add(ipend)
                                    Else
                                    End If
                                End If
                            End If
                        Next
                    End If


                    ''''
                    '''' /SendFile Sender File FileName
                    '''' Hier wird eine vom Client gesendete Datei angenommen und gespeichert
                    ''''
                    If tmp.Contains("/SendFile") Then
                        Log(ipend & ": Recv SendFilePacket")
                        Console.WriteLine(ipend & ": Recv SendFilePacket by (see logfile)")
                        Dim str() = {tmp}
                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)
                            Dim User As String = (splitString(1))
                            Dim BaseFile As String = (splitString(2))
                            Dim FileName As String = (splitString(3))
                            FileName = FileName.Replace("[+1]", " ")
                            Dim SenderUsername As String = (splitString(4))
                            Dim SenderPassword As String = (splitString(5))
                            Console.WriteLine(ipend & ": Recvd File")
                            Log(ipend & ": Recvd File")
                            If (splitString(2).Length < MaxFileSize) Then

                                If CheckIfUserVerified(SenderUsername, SenderPassword) = True Then
                                    If Not IpTimeOutList.Contains(ipend) Then
                                        If Not (My.Computer.FileSystem.FileExists(My.Computer.FileSystem.CurrentDirectory & "\Files\" & FileName & ".txt")) Then

                                            Dim objWriter As New System.IO.StreamWriter(My.Computer.FileSystem.CurrentDirectory & "\Files\" & FileName & ".txt")
                                            objWriter.Write(BaseFile)
                                            objWriter.Close()
                                            IpTimeOutList.Add(ipend)
                                            SendPrivatePacket("/FileAccepted " & SenderUsername, ipend)
                                            Log(ipend & ": Recv SendFilePacket by " & SenderUsername)
                                            Console.WriteLine(ipend & ": FileAccepted")
                                            Dim FileList As String = ""
                                            Dim dir As New DirectoryInfo(My.Computer.FileSystem.CurrentDirectory & "\Files\")
                                            For Each f In dir.GetFiles()
                                                FileList = FileList & "[~1]" & f.Name & "[+1]"
                                            Next
                                            SendPrivatePacket("/SendFileListToClient " & splitString(1) & " " & FileList, ipend)
                                        Else
                                            SendPrivatePacket("/FileAlreadyExist " & SenderUsername, ipend)
                                            Console.WriteLine(ipend & ": File does already exist")
                                        End If

                                    End If
                                End If
                            End If
                            Log("--------------------------------------------------------------------")
                            Console.WriteLine("--------------------------------------------------------------------")
                        Next
                    End If


                    ''''
                    '''' /RequestFile RequestedFile TargetUser
                    '''' Hier wird eine angeforderte Datei an den Client gesendet
                    ''''
                    If tmp.Contains("/RequestUpload") Then
                        Console.WriteLine(ipend & ": Recv RequestUploadPacket")
                        Log(ipend & ": Recv RequestUploadPacket")
                        Dim str() = {tmp}
                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)
                            Console.WriteLine(ipend & ": RecvFile:" & splitString(1) & "  |  RecvTarget:" & splitString(2))
                            Log(ipend & ": RecvFile:" & splitString(1) & "  |  RecvTarget:" & splitString(2))
                            Try
                                Dim fileReader As String
                                fileReader = My.Computer.FileSystem.ReadAllText(My.Computer.FileSystem.CurrentDirectory & "\Files\" & splitString(1) & ".txt")
                                SendPrivatePacket("/SendFileToClient " & " " & splitString(2) & " " & fileReader, ipend)
                            Catch
                            End Try
                            Console.WriteLine("--------------------------------------------------------------------")
                            Log("--------------------------------------------------------------------")
                        Next
                    End If

                    ''''
                    '''' /RequestFileList
                    '''' Hier wird der FilesOrdner-Inhalt an den Client gesendet
                    ''''
                    If tmp.Contains("/RequestFileList") Then
                        Console.WriteLine(ipend & ": Recv RequestFileListPacket")
                        Log(ipend & ": Recv RequestFileListPacket")
                        Dim str() = {tmp}
                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)

                            Dim FileList As String = ""
                            Dim dir As New DirectoryInfo(My.Computer.FileSystem.CurrentDirectory & "\Files\")
                            For Each f In dir.GetFiles()
                                FileList = FileList & "[~1]" & f.Name & "[+1]"
                            Next
                            SendPrivatePacket("/SendFileListToClient " & splitString(1) & " " & FileList, ipend)
                        Next


                        Console.WriteLine("--------------------------------------------------------------------")
                        Log("--------------------------------------------------------------------")

                    End If

                    ''''
                    '''' /RequestImage TargetUser PacketID
                    '''' Hier wird das Profilbild eines Benutzers ausgelesen
                    ''''
                    If tmp.Contains("/RequestImage") Then
                        Console.WriteLine(ipend & ": Recv RequestImagePacket")
                        Log(ipend & ": Recv RequestImagePacket")
                        Dim str() = {tmp}
                        For Each Word In str
                            Dim regx = New Regex(" +")
                            Dim splitString = regx.Split(Word)
                            Console.WriteLine(ipend & ": RecvTarget:" & splitString(1) & "  |  PacketID:" & splitString(2))
                            Log(ipend & ": RecvTarget:" & splitString(1) & "  |  PacketID:" & splitString(2))
                            Console.WriteLine(ipend & ": Requested " & """" & splitString(1) & """" & "  image.")
                            Log(ipend & ": Requested " & """" & splitString(1) & """" & "  image.")
                            Try
                                Dim fileReader As String
                                fileReader = My.Computer.FileSystem.ReadAllText(My.Computer.FileSystem.CurrentDirectory & "\Images\" & splitString(1) & ".txt")
                                SendPrivatePacket("/SendRequestedImage " & splitString(2) & " " & splitString(1) & " " & fileReader, ipend)
                            Catch
                            End Try
                            Console.WriteLine("--------------------------------------------------------------------")
                            Log("--------------------------------------------------------------------")
                        Next
                    End If
                Catch
                End Try

            Catch
                Try
                    Dim ipend As String = (IPAddress.Parse(CType(client.Client.RemoteEndPoint, IPEndPoint).Address.ToString())).ToString()
                    list.Remove(con)
                    con.stream.Close()
                    con.stream.Dispose()
                    con.streamw.Close()
                    con.streamw.Dispose()
                    con.streamr.Close()
                    con.streamr.Dispose()


                    Dim pos As Int32
                    Dim listItem As ListViewItem

                    For pos = LvUserWithIp.Items.Count - 1 To 0 Step -1
                        listItem = LvUserWithIp.Items(pos)
                        If listItem.SubItems(1).Text = ipend Then
                            LvUserWithIp.Items.Remove(listItem)
                        End If
                    Next

                    Console.ForegroundColor = ConsoleColor.Red
                    Console.WriteLine(ipend & ": lost connection.")
                    Log(ipend & ": lost connection.")
                    Console.WriteLine("--------------------------------------------------------------------")
                    Log("--------------------------------------------------------------------")
                    ConnectedUsers = ConnectedUsers - 1
                    SendPacket("/OnlineUsers " & ConnectedUsers)
                    Console.ResetColor()
                    Users = Users - 1
                Catch
                End Try
                Exit Do
            End Try

        Loop
    End Sub
End Class


